=== modified file '.bzrignore'
--- .bzrignore	2010-03-23 15:44:51 +0000
+++ .bzrignore	2009-04-01 14:40:05 +0000
@@ -7,5 +7,3 @@
 *.log
 _trial_temp
 loggerhead-memprofile
-docs/_build/doctrees
-docs/_build/html

=== modified file 'NEWS'
--- NEWS	2010-02-26 04:38:23 +0000
+++ NEWS	2009-06-25 03:39:27 +0000
@@ -2,20 +2,6 @@
 =============================
 
 dev [future]
-------------
-
-    - Show svn/git/hg revision ids in loggerhead revision view.
-      (Jelmer Vernooij)
-
-    - Fix .bzr/smart access to branches in shared repos. (You also need
-      a version of bzr with bug #348308 fixed.) (Andrew Bennetts)
-
-    - Support FastCGI, SCGI and AJP using flup. (Denis Martinez)
-
-    - Repository.get_revision_inventory() was removed in bzr 2.2; use
-      Repository.get_inventory() instead. (Matt Nordhoff, #528194)
-
-1.17 [20Aug2009]
 ---------------
 
     - Add bug links in revision informations (Alexandre Garnier, #314052)
@@ -163,11 +149,6 @@
     - tags are now displayed. (Cris Boylan, Alexandre Garnier, Michael
       Hudson, #246739)
 
-    - Display Loggerhead's version number at the bottom of the page, and
-      add a <meta> generator tag also including the version numbers of
-      its dependencies. (Matt Nordhoff, #370155)
-
-
 1.10 [22Dec2008]
 ---------------
 

=== modified file 'README'
--- README	2009-11-27 18:06:53 +0000
+++ README	2009-05-27 12:52:49 +0000
@@ -1,7 +1,7 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.17 for Bazaar 1.17 ]
+[ Version 1.10 for Bazaar 1.6 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
@@ -25,9 +25,6 @@
 4) Paste Deploy  (optional, needed when proxying through Apache)
    On Ubuntu, `sudo apt-get install python-pastedeploy`
    or use `easy_install PasteDeploy`
-5) flup (optional, needed to use FastCGI, SCGI or AJP)
-   On Ubuntu, `sudo apt-get install python-flup`
-   or use `easy_install flup`
 
 Then simply run the 'serve-branches' with the branch you want to
 serve on the command line:
@@ -43,7 +40,7 @@
 Loggerhead will notice and refresh, and Bazaar uses its own branch
 locking to prevent corruption.
 
-To run loggerhead as a linux daemon:
+To run loggerhead as a linux daemon: 
 1) Copy loggerheadd to /etc/init.d
 2) Edit the file to configure where your loggerhead is installed, and which
    serve-branches options you would like.
@@ -102,7 +99,6 @@
 You need to have the plugin installed and each branch indexed to allow
 searching on branches.
 
-
 SUPPORT
 -------
 
@@ -116,12 +112,3 @@
 Bugs are tracked on Launchpad; start at:
 
     https://bugs.launchpad.net/loggerhead
-
-
-HACKING
--------
-
-To run loggerhead tests, you will need the package python-nose,
-and run in the loggerhead directory:
-
-    nosetests

=== modified file '__init__.py'
--- __init__.py	2009-10-17 06:35:33 +0000
+++ __init__.py	2009-06-18 00:26:05 +0000
@@ -30,15 +30,13 @@
 starts a web server to browse the contents of a branch.
 """
 
-version_info = (1, 17, 0)
+version_info = (1, 11, 0)
 
 if __name__ == 'bzrlib.plugins.loggerhead':
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, [
-        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
-        (2, 0, 0), (2, 1, 0)])
+    require_any_api(bzrlib, [(1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0)])
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
@@ -59,9 +57,6 @@
             (DEFAULT_PORT,))
 
     def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
         # loggerhead internal code will try to 'import loggerhead', so
         # let's put it on the path if we can't find it in the existing path
         try:
@@ -72,7 +67,8 @@
 
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
-
+        from paste.httpexceptions import HTTPExceptionHandler
+        from paste.httpserver import serve
         if host is None:
             host = DEFAULT_HOST
         if port is None:
@@ -81,7 +77,7 @@
         if not transport.is_readonly():
             argv.insert(0, '--allow-writes')
         config = LoggerheadConfig(argv)
-        app = BranchesFromTransportRoot(transport.base, config)
+        app = BranchesFromTransportRoot(transport, config)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
 

=== removed directory 'docs'
=== removed file 'docs/Makefile'
--- docs/Makefile	2010-03-23 15:44:51 +0000
+++ docs/Makefile	1970-01-01 00:00:00 +0000
@@ -1,89 +0,0 @@
-# Makefile for Sphinx documentation
-#
-
-# You can set these variables from the command line.
-SPHINXOPTS    =
-SPHINXBUILD   = sphinx-build
-PAPER         =
-BUILDDIR      = _build
-
-# Internal variables.
-PAPEROPT_a4     = -D latex_paper_size=a4
-PAPEROPT_letter = -D latex_paper_size=letter
-ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
-
-.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
-
-help:
-	@echo "Please use \`make <target>' where <target> is one of"
-	@echo "  html      to make standalone HTML files"
-	@echo "  dirhtml   to make HTML files named index.html in directories"
-	@echo "  pickle    to make pickle files"
-	@echo "  json      to make JSON files"
-	@echo "  htmlhelp  to make HTML files and a HTML help project"
-	@echo "  qthelp    to make HTML files and a qthelp project"
-	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
-	@echo "  changes   to make an overview of all changed/added/deprecated items"
-	@echo "  linkcheck to check all external links for integrity"
-	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"
-
-clean:
-	-rm -rf $(BUILDDIR)/*
-
-html:
-	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
-	@echo
-	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
-
-dirhtml:
-	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
-	@echo
-	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."
-
-pickle:
-	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
-	@echo
-	@echo "Build finished; now you can process the pickle files."
-
-json:
-	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
-	@echo
-	@echo "Build finished; now you can process the JSON files."
-
-htmlhelp:
-	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
-	@echo
-	@echo "Build finished; now you can run HTML Help Workshop with the" \
-	      ".hhp project file in $(BUILDDIR)/htmlhelp."
-
-qthelp:
-	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
-	@echo
-	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
-	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
-	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/loggerhead.qhcp"
-	@echo "To view the help file:"
-	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/loggerhead.qhc"
-
-latex:
-	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
-	@echo
-	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
-	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
-	      "run these through (pdf)latex."
-
-changes:
-	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
-	@echo
-	@echo "The overview file is in $(BUILDDIR)/changes."
-
-linkcheck:
-	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
-	@echo
-	@echo "Link check complete; look for any errors in the above output " \
-	      "or in $(BUILDDIR)/linkcheck/output.txt."
-
-doctest:
-	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
-	@echo "Testing of doctests in the sources finished, look at the " \
-	      "results in $(BUILDDIR)/doctest/output.txt."

=== removed directory 'docs/_build'
=== removed directory 'docs/_static'
=== removed directory 'docs/_templates'
=== removed file 'docs/conf.py'
--- docs/conf.py	2010-03-25 10:25:13 +0000
+++ docs/conf.py	1970-01-01 00:00:00 +0000
@@ -1,194 +0,0 @@
-# -*- coding: utf-8 -*-
-#
-# loggerhead documentation build configuration file, created by
-# sphinx-quickstart on Tue Mar 23 10:49:50 2010.
-#
-# This file is execfile()d with the current directory set to its containing dir.
-#
-# Note that not all possible configuration values are present in this
-# autogenerated file.
-#
-# All configuration values have a default; values that are commented out
-# serve to show the default.
-
-import sys, os
-
-# If extensions (or modules to document with autodoc) are in another directory,
-# add these directories to sys.path here. If the directory is relative to the
-# documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.append(os.path.abspath('.'))
-
-# -- General configuration -----------------------------------------------------
-
-# Add any Sphinx extension module names here, as strings. They can be extensions
-# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = []
-
-# Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
-
-# The suffix of source filenames.
-source_suffix = '.rst'
-
-# The encoding of source files.
-#source_encoding = 'utf-8'
-
-# The master toctree document.
-master_doc = 'index'
-
-# General information about the project.
-project = u'Loggerhead'
-copyright = u'2010, Loggerhead team (https://launchpad.net/~loggerhead-team)'
-
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = '1.17'
-# The full version, including alpha/beta/rc tags.
-release = '1.17'
-
-# The language for content autogenerated by Sphinx. Refer to documentation
-# for a list of supported languages.
-#language = None
-
-# There are two options for replacing |today|: either, you set today to some
-# non-false value, then it is used:
-#today = ''
-# Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
-
-# List of documents that shouldn't be included in the build.
-#unused_docs = []
-
-# List of directories, relative to source directory, that shouldn't be searched
-# for source files.
-exclude_trees = ['_build']
-
-# The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
-
-# If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
-
-# If true, the current module name will be prepended to all description
-# unit titles (such as .. function::).
-#add_module_names = True
-
-# If true, sectionauthor and moduleauthor directives will be shown in the
-# output. They are ignored by default.
-#show_authors = False
-
-# The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
-
-# A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
-
-
-# -- Options for HTML output ---------------------------------------------------
-
-# The theme to use for HTML and HTML Help pages.  Major themes that come with
-# Sphinx are currently 'default' and 'sphinxdoc'.
-html_theme = 'default'
-
-# Theme options are theme-specific and customize the look and feel of a theme
-# further.  For a list of options available for each theme, see the
-# documentation.
-#html_theme_options = {}
-
-# Add any paths that contain custom themes here, relative to this directory.
-#html_theme_path = []
-
-# The name for this set of Sphinx documents.  If None, it defaults to
-# "<project> v<release> documentation".
-#html_title = None
-
-# A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
-
-# The name of an image file (relative to this directory) to place at the top
-# of the sidebar.
-#html_logo = None
-
-# The name of an image file (within the static path) to use as favicon of the
-# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
-# pixels large.
-#html_favicon = None
-
-# Add any paths that contain custom static files (such as style sheets) here,
-# relative to this directory. They are copied after the builtin static files,
-# so a file named "default.css" will overwrite the builtin "default.css".
-html_static_path = ['_static']
-
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
-
-# If true, SmartyPants will be used to convert quotes and dashes to
-# typographically correct entities.
-#html_use_smartypants = True
-
-# Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
-
-# Additional templates that should be rendered to pages, maps page names to
-# template names.
-#html_additional_pages = {}
-
-# If false, no module index is generated.
-#html_use_modindex = True
-
-# If false, no index is generated.
-#html_use_index = True
-
-# If true, the index is split into individual pages for each letter.
-#html_split_index = False
-
-# If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
-
-# If true, an OpenSearch description file will be output, and all pages will
-# contain a <link> tag referring to it.  The value of this option must be the
-# base URL from which the finished HTML is served.
-#html_use_opensearch = ''
-
-# If nonempty, this is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = ''
-
-# Output file base name for HTML help builder.
-htmlhelp_basename = 'loggerheaddoc'
-
-
-# -- Options for LaTeX output --------------------------------------------------
-
-# The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
-
-# The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
-
-# Grouping the document tree into LaTeX files. List of tuples
-# (source start file, target name, title, author, documentclass [howto/manual]).
-latex_documents = [
-  ('index', 'loggerhead.tex', u'Loggerhead Documentation',
-   u'Loggerhead team (https://launchpad.net/\\textasciitilde{}loggerhead-team)', 'manual'),
-]
-
-# The name of an image file (relative to this directory) to place at the top of
-# the title page.
-#latex_logo = None
-
-# For "manual" documents, if this is true, then toplevel headings are parts,
-# not chapters.
-#latex_use_parts = False
-
-# Additional stuff for the LaTeX preamble.
-#latex_preamble = ''
-
-# Documents to append as an appendix to all manuals.
-#latex_appendices = []
-
-# If false, no module index is generated.
-#latex_use_modindex = True

=== removed file 'docs/index.rst'
--- docs/index.rst	2010-03-25 10:28:03 +0000
+++ docs/index.rst	1970-01-01 00:00:00 +0000
@@ -1,211 +0,0 @@
-Loggerhead:  A web viewer for ``bzr`` branches
-==============================================
-
-Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
-a branch history, annotate files, view patches, perform searches, etc.
-Loggerhead is heavily based on `bazaar-webserve
-<https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
-based on `hgweb <http://mercurial.selenic.com/wiki/HgWebDirStepByStep>`_.
-
-
-Getting Started
----------------
-
-Loggerhead depends on the following Python libraries.:
-
-- SimpleTAL for templating.
-
-- simplejson for producing JSON data.
-
-- Paste for the server. (You need version 1.2 or newer of Paste).
-
-- Paste Deploy  (optional, needed when proxying through Apache).
-
-- flup (optional, needed to use FastCGI, SCGI or AJP).
-
-
-Installing Dependencies Using Ubuntu Packages
-#############################################
-
-.. code-block:: sh
-
-   $ sudo apt-get install python-simpletal
-   $ sudo apt-get install python-simplejson
-   $ sudo apt-get install python-paste
-   $ sudo apt-get install python-pastedeploy
-   $ sudo apt-get install python-flup
-
-Installing Dependencies Using :command:`easy_install`
-#####################################################
-
-.. code-block:: sh
-
-   $ easy_install \
-     -f http://www.owlfish.com/software/simpleTAL/py2compatible/download.html \
-     SimpleTAL
-   $ easy_install simplejson
-   $ easy_install Paste
-   $ easy_install PasteDeploy
-   $ easy_install flup
-
-
-Running the Standalone Loggerhead Server
-----------------------------------------
-
-After installing all the dependencies, you should be able to run
-:command:`serve-branches` with the branch you want to serve on the
-command line:
-
-.. code-block:: sh
-
-    ./serve-branches ~/path/to/branch
-
-By default, the script listens on port 8080, so head to
-http://localhost:8080/ in your browser to see the branch.
-
-You can also pass a directory that contains branches to the script,
-and it will serve a very simple directory listing at other pages.
-
-You may update the Bazaar branches being viewed at any time.
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
-
-See :doc:`serve-branches` for all command line options.
-
-Running Loggerhead as a Daemon
-------------------------------
-
-To run Loggerhead as a linux daemon:
-
-1) Copy the ``loggerheadd`` scipt to ``/etc/init.d``
-
-.. code-block:: sh
-
-   $ sudo cp ./loggerheadd /etc/init.d
-
-2) Edit the file to configure where your Loggerhead is installed, and which
-   serve-branches options you would like.
-
-.. code-block:: sh
-
-   $ sudo vim /etc/init.d/loggerheadd
-
-3) Register the service
-
-.. code-block:: sh
-
-   # on upstart based systems like Ubuntu run: 
-   $ sudo update-rc.d loggerheadd defaults
-
-   # on Sysvinit based systems like Centos or SuSE run:
-   $ sudo chkconfig --add loggerheadd
-
-
-Using Loggerhead as a Bazaar Plugin
-------------------------------------
-
-This branch contains experimental support for using Loggerhead as a Bazaar
-plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
-
-.. code-block:: sh
-
-   $ bzr branch lp:loggerhead ~/.bazaar/plugins/loggerhead
-   $ cd ~/myproject
-   $ bzr serve --http
-
-
-Using a Config File
--------------------
-
-To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
-under the branch's section:
-
-.. code-block:: ini
-
-    [/path/to/branch]
-    http_serve = False
-
-More configuration options to come soon.
-
-
-Serving Loggerhead behind Apache
---------------------------------
-
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this:
-
-.. code-block:: apache
-
-    <Location "/branches/">
-        ProxyPass http://127.0.0.1:8080/branches/
-        ProxyPassReverse http://127.0.0.1:8080/branches/
-    </Location>
-
-If Paste Deploy is installed, the :command:`serve-branches` script can be
-run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify is using
-``--prefix=/some_path``.
-
-
-Search
-------
-
-Search is currently supported by using the bzr-search plugin (available
-at: https://launchpad.net/bzr-search ).
-
-You need to have the plugin installed and each branch indexed to allow
-searching on branches.
-
-Command-Line Reference
-----------------------
-
-.. toctree::
-   :maxdepth: 2
-
-   serve-branches
-   start-loggerhead
-   stop-loggerhead
-
-
-Support
--------
-
-Discussion should take place on the bazaar-dev mailing list at
-mailto:bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
-
-Bugs are tracked on Launchpad; start at:
-
-    https://bugs.launchpad.net/loggerhead
-
-
-Hacking
--------
-
-To run Loggerhead tests, you will need to install the package ``python-nose``,
-and run its :command:`nosetests` script in the Loggerhead directory:
-
-.. code-block:: sh
-
-    nosetests
-
-
-License
--------
-
-GNU GPLv2 or later.
-
-See Also
---------
-
-https://launchpad.net/loggerhead
-
-Index
-=====
-
-- :ref:`genindex`

=== removed file 'docs/make.bat'
--- docs/make.bat	2010-03-23 15:44:51 +0000
+++ docs/make.bat	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-@ECHO OFF
-
-REM Command file for Sphinx documentation
-
-set SPHINXBUILD=sphinx-build
-set BUILDDIR=_build
-set ALLSPHINXOPTS=-d %BUILDDIR%/doctrees %SPHINXOPTS% .
-if NOT "%PAPER%" == "" (
-	set ALLSPHINXOPTS=-D latex_paper_size=%PAPER% %ALLSPHINXOPTS%
-)
-
-if "%1" == "" goto help
-
-if "%1" == "help" (
-	:help
-	echo.Please use `make ^<target^>` where ^<target^> is one of
-	echo.  html      to make standalone HTML files
-	echo.  dirhtml   to make HTML files named index.html in directories
-	echo.  pickle    to make pickle files
-	echo.  json      to make JSON files
-	echo.  htmlhelp  to make HTML files and a HTML help project
-	echo.  qthelp    to make HTML files and a qthelp project
-	echo.  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter
-	echo.  changes   to make an overview over all changed/added/deprecated items
-	echo.  linkcheck to check all external links for integrity
-	echo.  doctest   to run all doctests embedded in the documentation if enabled
-	goto end
-)
-
-if "%1" == "clean" (
-	for /d %%i in (%BUILDDIR%\*) do rmdir /q /s %%i
-	del /q /s %BUILDDIR%\*
-	goto end
-)
-
-if "%1" == "html" (
-	%SPHINXBUILD% -b html %ALLSPHINXOPTS% %BUILDDIR%/html
-	echo.
-	echo.Build finished. The HTML pages are in %BUILDDIR%/html.
-	goto end
-)
-
-if "%1" == "dirhtml" (
-	%SPHINXBUILD% -b dirhtml %ALLSPHINXOPTS% %BUILDDIR%/dirhtml
-	echo.
-	echo.Build finished. The HTML pages are in %BUILDDIR%/dirhtml.
-	goto end
-)
-
-if "%1" == "pickle" (
-	%SPHINXBUILD% -b pickle %ALLSPHINXOPTS% %BUILDDIR%/pickle
-	echo.
-	echo.Build finished; now you can process the pickle files.
-	goto end
-)
-
-if "%1" == "json" (
-	%SPHINXBUILD% -b json %ALLSPHINXOPTS% %BUILDDIR%/json
-	echo.
-	echo.Build finished; now you can process the JSON files.
-	goto end
-)
-
-if "%1" == "htmlhelp" (
-	%SPHINXBUILD% -b htmlhelp %ALLSPHINXOPTS% %BUILDDIR%/htmlhelp
-	echo.
-	echo.Build finished; now you can run HTML Help Workshop with the ^
-.hhp project file in %BUILDDIR%/htmlhelp.
-	goto end
-)
-
-if "%1" == "qthelp" (
-	%SPHINXBUILD% -b qthelp %ALLSPHINXOPTS% %BUILDDIR%/qthelp
-	echo.
-	echo.Build finished; now you can run "qcollectiongenerator" with the ^
-.qhcp project file in %BUILDDIR%/qthelp, like this:
-	echo.^> qcollectiongenerator %BUILDDIR%\qthelp\loggerhead.qhcp
-	echo.To view the help file:
-	echo.^> assistant -collectionFile %BUILDDIR%\qthelp\loggerhead.ghc
-	goto end
-)
-
-if "%1" == "latex" (
-	%SPHINXBUILD% -b latex %ALLSPHINXOPTS% %BUILDDIR%/latex
-	echo.
-	echo.Build finished; the LaTeX files are in %BUILDDIR%/latex.
-	goto end
-)
-
-if "%1" == "changes" (
-	%SPHINXBUILD% -b changes %ALLSPHINXOPTS% %BUILDDIR%/changes
-	echo.
-	echo.The overview file is in %BUILDDIR%/changes.
-	goto end
-)
-
-if "%1" == "linkcheck" (
-	%SPHINXBUILD% -b linkcheck %ALLSPHINXOPTS% %BUILDDIR%/linkcheck
-	echo.
-	echo.Link check complete; look for any errors in the above output ^
-or in %BUILDDIR%/linkcheck/output.txt.
-	goto end
-)
-
-if "%1" == "doctest" (
-	%SPHINXBUILD% -b doctest %ALLSPHINXOPTS% %BUILDDIR%/doctest
-	echo.
-	echo.Testing of doctests in the sources finished, look at the ^
-results in %BUILDDIR%/doctest/output.txt.
-	goto end
-)
-
-:end

=== removed file 'docs/serve-branches.rst'
--- docs/serve-branches.rst	2010-03-25 10:25:13 +0000
+++ docs/serve-branches.rst	1970-01-01 00:00:00 +0000
@@ -1,115 +0,0 @@
-:command:`serve-branches`
-=========================
-
-The :command:`serve-branches` script runs a standalone Loggerhead server in
-the foreground.
-
-.. program:: serve-branches
-
-Usage
------
-
-.. code-block:: sh
-
-   serve-branches [OPTIONS] <target directory>
-
-Options
--------
-
-.. cmdoption:: --user-dirs
-
-    Serve user directories as ``~user`` (requires ``--trunk-dir``).
-
-    If both options are set, then for requests where the CGI ``PATH_INFO``
-    starts with "/~<name>", serve branches under the <name> directory.
-
-.. cmdoption:: --trunk-dir=DIR
-
-    The directory that contains the trunk branches (requires ``--user-dirs``).
-
-    If both options are set, then for requests where the CGI ``PATH_INFO``
-    does not start with "/~<name>", serve branches under DIR.
-
-.. cmdoption:: --port
-
-    Listen on the given port.
-    
-    Defaults to 8080.
-
-.. cmdoption:: --host
-
-    Listen on the interface corresponding to the given IP. 
-    
-    Defaults to listening on all interfaces, i.e., "0.0.0.0".
-
-.. cmdoption:: --protocol
-
-    Serve the application using the specified protocol.
-    
-    Can be one of: "http", "scgi", "fcgi", "ajp" (defaults to "http").
-
-.. cmdoption:: --prefix
-
-    Set the supplied value as the CGI ``SCRIPT_NAME`` for the application.
-
-    This option is intended for use when serving Loggerhead behind a
-    reverse proxy, with Loggerhead being "mounted" at a directory below
-    the root.  E.g., if the reverse proxy translates requests for
-    ``http://example.com/loggerhead`` onto the standalone Loggerhead process,
-    that process should be run with ``--prefix=/loggerhead``.
-
-.. cmdoption:: --log-folder=LOG_FOLDER
-
-    The directory in which to place Loggerhead's log files.
-    
-    Defaults to the current directory.
-
-.. cmdoption:: --cache-dir=SQL_CACHE_DIR
-
-    The directory in which to place the SQL cache.
-
-    Defaults to the current directory.
-
-.. cmdoption:: --use-cdn
-   
-    Serve YUI javascript libraries from Yahoo!'s CDN.
-
-.. cmdoption:: --allow-writes
-   
-    Allow writing to the Bazaar server.
-    
-    Setting this option keeps Loggerhead from adding a 'readonly+' prefix
-    to the base URL of is to make visible the display of instructions for
-    checking out the 'public_branch' URL for the branch being browsed.
-
-.. cmdoption:: -h, --help
-
-    Print the help message and exit
-
-.. cmdoption:: --version
-
-    Print the software version and exit.
-
-Debugging Options
------------------
-
-The following options are only useful when developing / debugging Loggerhead
-itself.
-
-.. cmdoption:: --profile
-   
-    Generate per-request callgrind profile data.
-    
-    Data for each request is written to a file ``%d-stats.callgrind``,
-    where ``%d`` is replaced by the sequence number of the request.
-
-.. cmdoption:: --memory-profile
-
-    Profile the memory usage using the `Dozer
-    <http://pypi.python.org/pypi/Dozer>`_ middleware.
-
-.. cmdoption:: --reload
-
-    Restart the application when any of its python file change.
-    
-    This option should only used for development purposes.

=== removed file 'docs/start-loggerhead.rst'
--- docs/start-loggerhead.rst	2010-03-25 10:25:13 +0000
+++ docs/start-loggerhead.rst	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-:command:`start-loggerhead`
-===========================
-
-The :command:`start-loggerhead` command starts a new standalone Loggerhead
-server.  By default, the server runs in the background (daemonized).
-
-.. program:: start-loggerhead
-
-Usage
------
-
-.. code-block:: sh
-
-   start-loggerhead [OPTIONS]
-
-Options
--------
-
-.. cmdoption:: --version
-
-    Print the software version and exit.
-
-.. cmdoption:: -h, --help
-
-    Show this help message and exit
-
-.. cmdoption:: --foreground
-
-    Run in the foreground;  don't daemonize.
-
-.. cmdoption:: -C, --check
-
-    Only start if not already running (useful for cron jobs)
-
-.. cmdoption:: -p, --pidfile=PIDFILE
-
-    override pid file location
-
-.. cmdoption:: -c, --config-file=CONFIGFILE
-
-   Override configuration file location [XXX default is
-   :file:`/etc/loggerhead.conf`]
-
-.. cmdoption:: --log-folder=LOG_FOLDER
-
-    The directory [XXX in which] to place log files

=== removed file 'docs/stop-loggerhead.rst'
--- docs/stop-loggerhead.rst	2010-03-25 10:25:13 +0000
+++ docs/stop-loggerhead.rst	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-:command:`stop-loggerhead`
-======================================================================
-
-The :command:`stop-loggerhead` command stops the currently running Loggerhead
-daemon.
-
-.. program:: stop-loggerhead
-
-Usage
------
-
-.. code-block:: sh
-
-   stop-loggerhead [OPTIONS]
-
-.. cmdoption:: -p, --pidfile=PIDFILE
-
-   override pid file location

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2009-08-20 13:30:37 +0000
+++ loggerhead/__init__.py	2009-05-29 13:39:28 +0000
@@ -22,8 +22,8 @@
 
 import pkg_resources
 
-__version__ = '1.17'
-required_bzrlib = (1, 17)
+__version__ = '1.10'
+required_bzrlib = (1, 13)
 
 pkg_resources.get_distribution('Paste>=1.6')
 try:

=== modified file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2009-11-26 03:44:40 +0000
+++ loggerhead/apps/__init__.py	2009-02-19 01:24:20 +0000
@@ -4,15 +4,10 @@
 
 from paste import urlparser, fileapp
 
-from loggerhead.util import convert_file_errors
-
 static = os.path.join(
     os.path.dirname(os.path.dirname(__file__)), 'static')
 
 static_app = urlparser.make_static(None, static)
 
-favicon_app = convert_file_errors(fileapp.FileApp(
-    os.path.join(static, 'images', 'favicon.ico')))
-
-robots_app = convert_file_errors(fileapp.FileApp(
-    os.path.join(static, 'robots.txt')))
+favicon_app = fileapp.FileApp(os.path.join(static, 'images', 'favicon.ico'))
+robots_app = fileapp.FileApp(os.path.join(static, 'robots.txt'))

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
+++ loggerhead/apps/branch.py	2009-05-28 08:17:40 +0000
@@ -52,7 +52,7 @@
         self._config = config
         self.friendly_name = friendly_name
         self.branch_link = branch_link  # Currently only used in Launchpad
-        self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
+        self.log = logging.getLogger('loggerhead.%s' % friendly_name)
         if graph_cache is None:
             graph_cache = bzrlib.lru_cache.LRUCache(10)
         self.graph_cache = graph_cache
@@ -86,7 +86,7 @@
         qs = []
         for k, v in kw.iteritems():
             if v is not None:
-                qs.append('%s=%s' % (k, urllib.quote(v)))
+                qs.append('%s=%s'%(k, urllib.quote(v)))
         qs = '&'.join(qs)
         return request.construct_url(
             self._environ, script_name=self._url_base,

=== modified file 'loggerhead/apps/error.py'
--- loggerhead/apps/error.py	2009-10-17 08:47:38 +0000
+++ loggerhead/apps/error.py	2008-10-24 02:26:05 +0000
@@ -53,6 +53,6 @@
 
 
 def errapp(environ, start_response):
-    """Default (and trivial) error handling WSGI application."""
+    '''Default (and trivial) error handling WSGI application.'''
     c = ErrorUI(environ['branch'], environ['exc_info'])
     return c(environ, start_response)

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2009-11-26 03:20:53 +0000
+++ loggerhead/apps/transport.py	2009-06-25 01:53:46 +0000
@@ -20,7 +20,6 @@
 
 from bzrlib import branch, errors, lru_cache, urlutils
 from bzrlib.config import LocationConfig
-from bzrlib.smart import request
 from bzrlib.transport import get_transport
 from bzrlib.transport.http import wsgi
 
@@ -29,7 +28,7 @@
 from paste import urlparser
 
 from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps import favicon_app, robots_app, static_app
+from loggerhead.apps import favicon_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
 
 _bools = {
@@ -55,13 +54,10 @@
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch,
-            name,
+            branch, name,
             {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache,
-            is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'),
-            )
+            self.root.graph_cache, is_root=is_root,
+            use_cdn=self._config.get_option('use_cdn'))
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -86,9 +82,8 @@
 
     def app_for_bazaar_data(self, relpath):
         if relpath == '/.bzr/smart':
-            root_transport = get_transport_for_thread(self.root.base)
-            wsgi_app = wsgi.SmartWSGIApp(root_transport)
-            return wsgi.RelpathSetter(wsgi_app, '', 'loggerhead.path_info')
+            wsgi_app = wsgi.SmartWSGIApp(self.transport)
+            return wsgi.RelpathSetter(wsgi_app, '', 'PATH_INFO')
         else:
             # TODO: Use something here that uses the transport API
             # rather than relying on the local filesystem API.
@@ -98,7 +93,7 @@
                 base = base[len(readonly_prefix):]
             try:
                 path = urlutils.local_path_from_url(base)
-            except errors.InvalidURL:
+            except errors.InvalidURL, e:
                 raise httpexceptions.HTTPNotFound()
             else:
                 return urlparser.make_static(None, path)
@@ -132,13 +127,13 @@
 _transport_store = threading.local()
 
 def get_transport_for_thread(base):
+    """ """
     thread_transports = getattr(_transport_store, 'transports', None)
     if thread_transports is None:
         thread_transports = _transport_store.transports = {}
     if base in thread_transports:
         return thread_transports[base]
     transport = get_transport(base)
-    thread_transports[base] = transport
     return transport
 
 
@@ -151,15 +146,12 @@
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        environ['loggerhead.path_info'] = environ['PATH_INFO']
         if environ['PATH_INFO'].startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'
             return static_app(environ, start_response)
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
-        elif environ['PATH_INFO'] == '/robots.txt':
-            return robots_app(environ, start_response)
         else:
             transport = get_transport_for_thread(self.base)
             return BranchesFromTransportServer(
@@ -176,7 +168,6 @@
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        environ['loggerhead.path_info'] = environ['PATH_INFO']
         path_info = environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
@@ -184,13 +175,12 @@
             return static_app(environ, start_response)
         elif path_info == '/favicon.ico':
             return favicon_app(environ, start_response)
-        elif environ['PATH_INFO'] == '/robots.txt':
-            return robots_app(environ, start_response)
         else:
             transport = get_transport_for_thread(self.base)
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
+                new_transport = transport.clone(segment[1:])
                 return BranchesFromTransportServer(
                     transport.clone(segment[1:]), self, segment)(
                     environ, start_response)

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-11-23 22:45:46 +0000
+++ loggerhead/config.py	2009-06-03 23:21:52 +0000
@@ -11,7 +11,7 @@
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
-"""Configuration tools for Loggerhead."""
+'''Configuration tools for Loggerhead.'''
 
 from optparse import OptionParser
 import sys
@@ -37,7 +37,7 @@
         sql_dir=None,
         allow_writes=False,
         )
-    parser.add_option("--user-dirs", action="store_true",
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
                       help="Serve user directories as ~user.")
     parser.add_option("--trunk-dir", metavar="DIR",
                       help="The directory that contains the trunk branches.")
@@ -46,34 +46,32 @@
                             "(defaults to 8080)."))
     parser.add_option("--host", dest="user_host",
                       help="Host Loggerhead should listen on.")
-    parser.add_option("--protocol", dest="protocol",
-                      help=("Protocol to use: http, scgi, fcgi, ajp"
-                           "(defaults to http)."))
-    parser.add_option("--memory-profile", action="store_true",
-                      help="Profile the memory usage using Dozer.")
+    parser.add_option('--memory-profile', action='store_true',
+                      dest='memory_profile',
+                      help='Profile the memory usage using Dozer.')
     parser.add_option("--prefix", dest="user_prefix",
                       help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true",
+    parser.add_option("--profile", action="store_true", dest="profile",
                       help="Generate callgrind profile data to "
                         "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true",
+    parser.add_option("--reload", action="store_true", dest="reload",
                       help="Restarts the application when changing python"
                            " files. Only used for development purposes.")
-    parser.add_option("--log-folder",
-                      help="The directory to place log files in.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
     parser.add_option("--use-cdn", action="store_true", dest="use_cdn",
                       help="Serve YUI from Yahoo!'s CDN")
     parser.add_option("--cache-dir", dest="sql_dir",
                       help="The directory to place the SQL cache in")
-    parser.add_option("--allow-writes", action="store_true",
+    parser.add_option('--allow-writes', action='store_true',
                       help="Allow writing to the Bazaar server.")
     return parser
 
 
 class LoggerheadConfig(object):
-    """A configuration object."""
+    '''A configuration object.'''
 
     def __init__(self, argv=None):
         if argv is None:
@@ -88,13 +86,12 @@
 
     def get_option(self, option):
         """Get the value for the config option, either 
-        from ~/.bazaar/bazaar.conf or from the command line.
-        All loggerhead-specific settings start with 'http_'
-        """
+           from ~/.bazaar/bazaar.conf or from the command line.
+           All loggerhead-specific settings start with 'http_'"""
         global_config = config.GlobalConfig().get_user_option('http_'+option)
         cmd_config = getattr(self._options, option)
         if global_config is not None and (
-            cmd_config is None or cmd_config is False):
+                cmd_config is None or cmd_config is False):
             return global_config
         else:
             return cmd_config
@@ -111,3 +108,4 @@
     def arg_count(self):
         """Return the number of args from the option parser."""
         return len(self._args)
+

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/__init__.py	2009-03-02 05:44:20 +0000
@@ -70,7 +70,7 @@
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-05-16 06:05:56 +0000
@@ -62,10 +62,10 @@
         try:
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
-            # bail out; this isn't displayable text
-            yield util.Container(parity=0, lineno=1, status='same',
-                                 text='(This is a binary file.)',
-                                 change=util.Container())
+                # bail out; this isn't displayable text
+                yield util.Container(parity=0, lineno=1, status='same',
+                                     text='(This is a binary file.)',
+                                     change=util.Container())
         else:
             if highlight is not None:
                 hl_lines = highlight(file_name, file_text, encoding)
@@ -95,7 +95,7 @@
                     change=change, text=hl_lines[lineno - 1])
                 lineno += 1
 
-        self.log.debug('annotate: %r secs' % (time.time() - z,))
+        self.log.debug('annotate: %r secs' % (time.time() - z))
 
     def get_values(self, path, kwargs, headers):
         history = self._history

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/atom_ui.py	2009-06-06 09:09:55 +0000
@@ -26,6 +26,7 @@
 
     def get_values(self, path, kwargs, headers):
         history = self._history
+        revid = self.get_revid()
         pagesize = int(20)#self._branch.config.get('pagesize', '20'))
 
         revid_list = history.get_file_view(history.last_revid, None)

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/diff_ui.py	2008-12-05 18:52:44 +0000
@@ -38,7 +38,7 @@
         z = time.time()
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -73,7 +73,7 @@
         headers = [
             ('Content-Type', 'application/octet-stream'),
             ('Content-Length', len(content)),
-            ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
+            ('Content-Disposition', 'attachment; filename=%s' % filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/directory_ui.py	2009-06-02 13:39:33 +0000
@@ -57,7 +57,7 @@
             def static_url(path):
                 return self._static_url_base + path
         self._branch = _branch
-        self._history_callable = lambda: None
+        self._history_callable = lambda:None
         self._name = name
         self._static_url_base = static_url_base
         self.transport = transport

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
+++ loggerhead/controllers/download_ui.py	2009-02-06 05:53:36 +0000
@@ -19,6 +19,7 @@
 
 import logging
 import mimetypes
+import time
 import urllib
 
 from paste import httpexceptions
@@ -33,11 +34,12 @@
 
     def __call__(self, environ, start_response):
         # /download/<rev_id>/<file_id>/[filename]
+        z = time.time()
 
         h = self._history
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -63,7 +65,7 @@
             ('Content-Type', mime_type),
             ('Content-Length', len(content)),
             ('Content-Disposition',
-             "attachment; filename*=utf-8''%s" % (encoded_filename,)),
+             'attachment; filename*=utf-8\'\'%s' % encoded_filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/error_ui.py'
--- loggerhead/controllers/error_ui.py	2009-10-17 08:47:38 +0000
+++ loggerhead/controllers/error_ui.py	2008-12-05 18:52:44 +0000
@@ -28,19 +28,22 @@
     template_path = 'loggerhead.templates.error'
 
     def __init__(self, branch, exc_info):
-        super(ErrorUI, self).__init__(branch, lambda: None)
+        super(ErrorUI, self).__init__(branch, lambda:None)
         self.exc_info = exc_info
 
     def get_values(self, path, kwargs, response):
         exc_type, exc_object, exc_tb = self.exc_info
         description = StringIO()
         traceback.print_exception(exc_type, exc_object, None, file=description)
-        directory_breadcrumbs = util.directory_breadcrumbs(
-            self._branch.friendly_name, self._branch.is_root, 'changes')
+        directory_breadcrumbs = (
+            util.directory_breadcrumbs(
+                self._branch.friendly_name,
+                self._branch.is_root,
+                'changes'))
         return {
             'branch': self._branch,
             'error_title': ('An unexpected error occurred while'
-                            'processing the request:'),
+                            'proccesing the request:'),
             'error_description': description.getvalue(),
             'directory_breadcrumbs': directory_breadcrumbs,
         }

=== modified file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/filediff_ui.py	2009-03-28 14:26:37 +0000
@@ -79,10 +79,13 @@
     template_path = 'loggerhead.templates.filediff'
 
     def get_values(self, path, kwargs, headers):
+        history = self._history
+
         revid = urllib.unquote(self.args[0])
         compare_revid = urllib.unquote(self.args[1])
         file_id = urllib.unquote(self.args[2])
 
+        repository = self._history._branch.repository
         chunks = diff_chunks_for_file(
             self._history._branch.repository, file_id, compare_revid, revid)
 

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-08-04 04:08:03 +0000
+++ loggerhead/controllers/revision_ui.py	2009-04-29 19:55:16 +0000
@@ -96,13 +96,13 @@
         h.add_branch_nicks(change)
 
         if '.' in change.revno:
-            # Walk "up" though the merge-sorted graph until we find a
+            # Walk "down" though the merge-sorted graph until we find a
             # revision with merge depth 0: this is the revision that merged
             # this one to mainline.
             ri = self._history._rev_info
             i = self._history._rev_indices[change.revid]
             while ri[i][0][2] > 0:
-                i -= 1
+                i += 1
             merged_in = ri[i][0][3]
         else:
             merged_in = None

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2009-05-13 14:03:48 +0000
+++ loggerhead/daemon.py	2008-12-07 15:24:05 +0000
@@ -53,7 +53,7 @@
             pass
 
     f = open(pidfile, 'w')
-    f.write('%d\n' % (os.getpid(),))
+    f.write('%d\n' % os.getpid())
     f.close()
 
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2010-02-26 04:37:13 +0000
+++ loggerhead/history.py	2009-06-25 03:39:27 +0000
@@ -35,16 +35,36 @@
 import textwrap
 import threading
 
+from loggerhead import search
+from loggerhead import util
+from loggerhead.wholehistory import compute_whole_history_data
+
+import bzrlib
 import bzrlib.branch
 import bzrlib.delta
+import bzrlib.diff
 import bzrlib.errors
-import bzrlib.foreign
+import bzrlib.lru_cache
+import bzrlib.progress
 import bzrlib.revision
-
-from loggerhead import search
-from loggerhead import util
-from loggerhead.wholehistory import compute_whole_history_data
-
+import bzrlib.textfile
+import bzrlib.tsort
+import bzrlib.ui
+
+# bzrlib's UIFactory is not thread-safe
+uihack = threading.local()
+
+
+class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
+
+    def nested_progress_bar(self):
+        if getattr(uihack, '_progress_bar_stack', None) is None:
+            pbs = bzrlib.progress.ProgressBarStack(
+                      klass=bzrlib.progress.DummyProgress)
+            uihack._progress_bar_stack = pbs
+        return uihack._progress_bar_stack.get_nested()
+
+bzrlib.ui.ui_factory = ThreadSafeUIFactory()
 
 def is_branch(folder):
     try:
@@ -106,7 +126,6 @@
         return len(self.revid_list)
 
 class FileChangeReporter(object):
-
     def __init__(self, old_inv, new_inv):
         self.added = []
         self.modified = []
@@ -189,14 +208,8 @@
         """
         self._cache[key] = (revid, data)
 
-# Used to store locks that prevent multiple threads from building a 
-# revision graph for the same branch at the same time, because that can
-# cause severe performance issues that are so bad that the system seems
-# to hang.
-revision_graph_locks = {}
-revision_graph_check_lock = threading.Lock()
 
-class History(object):
+class History (object):
     """Decorate a branch to provide information for rendering.
 
     History objects are expected to be short lived -- when serving a request
@@ -234,33 +247,18 @@
         def update_missed_caches():
             for cache in missed_caches:
                 cache.set(cache_key, self.last_revid, self._rev_info)
-
-        # Theoretically, it's possible for two threads to race in creating
-        # the Lock() object for their branch, so we put a lock around
-        # creating the per-branch Lock().
-        revision_graph_check_lock.acquire()
-        try:
-            if cache_key not in revision_graph_locks:
-                revision_graph_locks[cache_key] = threading.Lock()
-        finally:
-            revision_graph_check_lock.release()
-
-        revision_graph_locks[cache_key].acquire()
-        try:
-            for cache in caches:
-                data = cache.get(cache_key, self.last_revid)
-                if data is not None:
-                    self._rev_info = data
-                    update_missed_caches()
-                    break
-                else:
-                    missed_caches.append(cache)
-            else:
-                whole_history_data = compute_whole_history_data(self._branch)
-                self._rev_info, self._rev_indices = whole_history_data
+        for cache in caches:
+            data = cache.get(cache_key, self.last_revid)
+            if data is not None:
+                self._rev_info = data
                 update_missed_caches()
-        finally:
-            revision_graph_locks[cache_key].release()
+                break
+            else:
+                missed_caches.append(cache)
+        else:
+            whole_history_data = compute_whole_history_data(self._branch)
+            self._rev_info, self._rev_indices = whole_history_data
+            update_missed_caches()
 
         if self._rev_indices is not None:
             self._revno_revid = {}
@@ -285,7 +283,7 @@
         self._branch = branch
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
-        self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
+        self.log = logging.getLogger('loggerhead.%s' % self._branch_nick)
 
         self.last_revid = branch.last_revision()
 
@@ -328,7 +326,7 @@
                 r.add(self._rev_info[i][0][1])
                 i += 1
             return r
-        while True:
+        while 1:
             if bzrlib.revision.is_null(revid):
                 return
             if introduced_revisions(revid) & revid_set:
@@ -517,7 +515,7 @@
     def get_inventory(self, revid):
         if revid not in self._inventory_cache:
             self._inventory_cache[revid] = (
-                self._branch.repository.get_inventory(revid))
+                self._branch.repository.get_revision_inventory(revid))
         return self._inventory_cache[revid]
 
     def get_path(self, revid, file_id):
@@ -571,14 +569,14 @@
             revnol = revno.split(".")
             revnos = ".".join(revnol[:-2])
             revnolast = int(revnol[-1])
-            if revnos in d:
+            if revnos in d.keys():
                 m = d[revnos][0]
                 if revnolast < m:
                     d[revnos] = (revnolast, revid)
             else:
                 d[revnos] = (revnolast, revid)
 
-        return [revid for (_, revid) in d.itervalues()]
+        return [d[revnos][1] for revnos in d.keys()]
 
     def add_branch_nicks(self, change):
         """
@@ -651,8 +649,12 @@
         Given a bzrlib Revision, return a processed "change" for use in
         templates.
         """
+        parents = [util.Container(revid=r,
+                   revno=self.get_revno(r)) for r in revision.parent_ids]
+
         message, short_message = clean_message(revision.message)
 
+
         tags = self._branch.tags.get_reverse_tag_dict()
 
         revtags = None
@@ -672,24 +674,10 @@
             'bugs': [bug.split()[0] for bug in revision.properties.get('bugs', '').splitlines()],
             'tags': revtags,
         }
-        if isinstance(revision, bzrlib.foreign.ForeignRevision):
-            foreign_revid, mapping = (rev.foreign_revid, rev.mapping)
-        elif ":" in revision.revision_id:
-            try:
-                foreign_revid, mapping = \
-                    bzrlib.foreign.foreign_vcs_registry.parse_revision_id(
-                        revision.revision_id)
-            except bzrlib.errors.InvalidRevisionId:
-                foreign_revid = None
-                mapping = None
-        else:
-            foreign_revid = None
-        if foreign_revid is not None:
-            entry["foreign_vcs"] = mapping.vcs.abbreviation
-            entry["foreign_revid"] = mapping.vcs.show_foreign_revid(foreign_revid)
         return util.Container(entry)
 
     def get_file_changes_uncached(self, entry):
+        repo = self._branch.repository
         if entry.parents:
             old_revid = entry.parents[0].revid
         else:
@@ -707,7 +695,7 @@
         entry.changes = changes
 
     def get_file(self, file_id, revid):
-        """Returns (path, filename, file contents)"""
+        "returns (path, filename, data)"
         inv = self.get_inventory(revid)
         inv_entry = inv[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
@@ -730,8 +718,8 @@
             text_changes: list((filename, file_id)),
         """
         repo = self._branch.repository
-        if (bzrlib.revision.is_null(old_revid) or
-            bzrlib.revision.is_null(new_revid)):
+        if bzrlib.revision.is_null(old_revid) or \
+               bzrlib.revision.is_null(new_revid):
             old_tree, new_tree = map(
                 repo.revision_tree, [old_revid, new_revid])
         else:
@@ -742,8 +730,8 @@
         bzrlib.delta.report_changes(new_tree.iter_changes(old_tree), reporter)
 
         return util.Container(
-            added=sorted(reporter.added, key=lambda x: x.filename),
-            renamed=sorted(reporter.renamed, key=lambda x: x.new_filename),
-            removed=sorted(reporter.removed, key=lambda x: x.filename),
-            modified=sorted(reporter.modified, key=lambda x: x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x: x.filename))
+            added=sorted(reporter.added, key=lambda x:x.filename),
+            renamed=sorted(reporter.renamed, key=lambda x:x.new_filename),
+            removed=sorted(reporter.removed, key=lambda x:x.filename),
+            modified=sorted(reporter.modified, key=lambda x:x.filename),
+            text_changes=sorted(reporter.text_changes, key=lambda x:x.filename))

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2009-07-07 23:52:24 +0000
+++ loggerhead/lsprof.py	2008-10-24 02:26:05 +0000
@@ -73,6 +73,7 @@
             d = d[:top]
         cols = "% 12s %12s %11.4f %11.4f   %s\n"
         hcols = "% 12s %12s %12s %12s %s\n"
+        cols2 = "+%12s %12s %11.4f %11.4f +  %s\n"
         file.write(hcols % ("CallCount", "Recursive", "Total(ms)",
                             "Inline(ms)", "module:lineno(function)"))
         for e in d:

=== modified file 'loggerhead/main.py'
--- loggerhead/main.py	2009-11-27 18:30:24 +0000
+++ loggerhead/main.py	2009-06-26 09:42:43 +0000
@@ -22,6 +22,7 @@
 import sys
 
 from bzrlib.plugin import load_plugins
+from bzrlib.transport import get_transport
 
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler, HTTPInternalServerError
@@ -39,7 +40,7 @@
     config = LoggerheadConfig(args)
 
     if config.get_option('show_version'):
-        print "loggerhead %s" % (__version__,)
+        print "loggerhead %s" % __version__
         sys.exit(0)
 
     if config.arg_count > 1:
@@ -151,21 +152,4 @@
     else:
         host = config.get_option('user_host')
 
-    if not config.get_option('protocol'):
-        protocol = 'http'
-    else:
-        protocol = config.get_option('protocol')
-
-    if protocol == 'http':
-        httpserver.serve(app, host=host, port=port)
-    else:
-        if protocol == 'fcgi':
-            from flup.server.fcgi import WSGIServer
-        elif protocol == 'scgi':
-            from flup.server.scgi import WSGIServer
-        elif protocol == 'ajp':
-            from flup.server.ajp import WSGIServer
-        else:
-            print 'Unknown protocol: %s.' % (protocol)
-            sys.exit(1)
-        WSGIServer(app, bindAddress=(host, int(port))).run()
+    httpserver.serve(app, host=host, port=port)

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-10-17 08:47:38 +0000
+++ loggerhead/middleware/profile.py	2009-04-01 22:50:25 +0000
@@ -1,12 +1,14 @@
-"""Profiling middleware for Paste."""
-
+'''Profiling middleware for paste.'''
+import cgi
+import logging
+import sys
 import threading
 
 from bzrlib.lsprof import profile
-
+from guppy import hpy
 
 class LSProfMiddleware(object):
-    """Paste middleware for profiling with lsprof."""
+    '''Paste middleware for profiling with lsprof.'''
 
     def __init__(self, app, global_conf=None):
         self.app = app
@@ -27,7 +29,9 @@
         try:
             ret, stats = profile(self.__run_app, environ, start_response)
             self.__count += 1
-            stats.save("%d-stats.callgrind" % (self.__count,), format="callgrind")
+            stats.save("%d-stats.callgrind" % self.__count, format="callgrind")
             return ret
         finally:
             self.lock.release()
+
+

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 03:38:04 +0000
+++ loggerhead/search.py	2009-04-17 01:50:05 +0000
@@ -17,7 +17,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
 _mod_index = None
 def import_search():
     global errors, _mod_index, FileTextHit, RevisionHit

=== modified file 'loggerhead/static/css/diff.css'
--- loggerhead/static/css/diff.css	2010-01-11 03:26:44 +0000
+++ loggerhead/static/css/diff.css	2009-06-17 20:28:20 +0000
@@ -31,7 +31,7 @@
     width:493px;
     margin:0px 0px 5px 0px;
 }
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags, .foreign-svn, .foreign-git, .foreign-hg {
+.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags {
     clear:both;
     margin:0px;
     padding:0px 0px 2px 18px;

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
+++ loggerhead/templatefunctions.py	2009-04-28 03:01:54 +0000
@@ -13,15 +13,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
 import cgi
 import os
-
-import pkg_resources
-
-import bzrlib
-
-import loggerhead
 from loggerhead.zptsupport import zpt
 
 
@@ -56,7 +49,7 @@
                     url, entry.revno, filename, '#' + filename)
     else:
         def file_link(filename):
-            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
                 url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
                 cgi.escape(entry.revno), cgi.escape(filename))
     return _pt('revisionfilechanges').expand(
@@ -100,7 +93,7 @@
         extra = ' ' + entry.branch_nick
     else:
         extra = ''
-    return '(%s%s)' % (entry.revno, extra)
+    return '(%s%s)'%(entry.revno, extra)
 
 
 @templatefunc
@@ -122,84 +115,11 @@
 
 @templatefunc
 def annotate_link(url, revno, path):
-    return '<a href="%s" title="Annotate %s">%s</a>' % (
+    return '<a href="%s" title="Annotate %s">%s</a>'%(
         url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):
-    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
         url(['/revision', revno, path]), frag, cgi.escape(path),
         cgi.escape(revno), cgi.escape(path))
-
-
-@templatefunc
-def loggerhead_version():
-    return loggerhead.__version__
-
-_cached_generator_string = None
-
-@templatefunc
-def generator_string():
-    global _cached_generator_string
-    if _cached_generator_string is None:
-        versions = []
-
-        # TODO: Errors -- e.g. from a missing/invalid __version__ attribute, or
-        # ValueError accessing Distribution.version -- should be non-fatal.
-
-        versions.append(('Loggerhead', loggerhead.__version__))
-
-        import sys
-        python_version = bzrlib._format_version_tuple(sys.version_info)
-        versions.append(('Python', python_version))
-
-        versions.append(('Bazaar', bzrlib.__version__))
-
-        Paste = pkg_resources.get_distribution('Paste')
-        versions.append(('Paste', Paste.version))
-
-        try:
-            PasteDeploy = pkg_resources.get_distribution('PasteDeploy')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('PasteDeploy', PasteDeploy.version))
-
-        import simpletal
-        versions.append(('SimpleTAL', simpletal.__version__))
-
-        try:
-            import pygments
-        except ImportError:
-            pass
-        else:
-            versions.append(('Pygments', pygments.__version__))
-
-        try:
-            from bzrlib.plugins import search
-        except ImportError:
-            pass
-        else:
-            bzr_search_version = bzrlib._format_version_tuple(
-                search.version_info)
-            versions.append(('bzr-search', bzr_search_version))
-
-        # TODO: On old Python versions, elementtree may be used.
-
-        try:
-            import simplejson
-        except ImportError:
-            pass
-        else:
-            versions.append(('simplejson', simplejson.__version__))
-
-        try:
-            Dozer = pkg_resources.get_distribution('Dozer')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('Dozer', Dozer.version))
-
-        version_strings = ("%s/%s" % t for t in versions)
-        _cached_generator_string = ' '.join(version_strings)
-    return _cached_generator_string

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-07-21 21:52:59 +0000
+++ loggerhead/templates/changelog.pt	2009-06-25 03:35:43 +0000
@@ -95,16 +95,12 @@
             </td>
             <td class="summcell">
               <div class="short_description">
-                <img tal:condition="python:entry.parents[1:]"
-                     tal:attributes="src python:branch.static_url('/static/images/ico_mergefrom.gif')" />
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
                    tal:content="entry/short_comment"></a>
               </div>
               <div class="long_description" style="display: none">
-                <img tal:condition="python:entry.parents[1:]"
-                     tal:attributes="src python:branch.static_url('/static/images/ico_mergefrom.gif')" />
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2009-11-27 00:14:35 +0000
+++ loggerhead/templates/directory.pt	2008-10-18 00:23:09 +0000
@@ -22,10 +22,10 @@
           
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
-                <a href="../"><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
+                <a href=".."><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
             </td>
             <td class="summcell" colspan="3">
-                <a href="../">..</a>
+                <a href="..">..</a>
             </td>
           </tr>
           <tal:block repeat="dir dirs">
@@ -50,12 +50,12 @@
             <tal:non-branch-row tal:condition="not:dir/branch">
               <tr tal:attributes="class string:blueRow${dir/parity}">
                 <td class="icocell">
-                    <a tal:attributes="href string:${dir/dirname}/">
+                    <a tal:attributes="href string:${dir/dirname}">
                         <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" alt="Folder" />
                     </a>
                 </td>
                 <td class="autcell">
-                  <a tal:attributes="href string:${dir/dirname}/" tal:content="dir/dirname" /></td>
+                  <a tal:attributes="href string:${dir/dirname}" tal:content="dir/dirname" /></td>
                 <td class="date"></td>
                 <td class="date" tal:content="dir/last_change"></td>
               </tr>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
+++ loggerhead/templates/inventory.pt	2009-02-10 04:25:11 +0000
@@ -90,7 +90,7 @@
             <!-- Show this if it's a symlink -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
                 <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
                     </a>
 
                  <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-06-24 02:35:46 +0000
+++ loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
@@ -3,8 +3,6 @@
 <html xmlns="http://www.w3.org/1999/xhtml" metal:define-macro="main">
   <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
-    <meta name="generator"
-          tal:attributes="content generator_string" />
 
     <title metal:define-slot="title"></title>
     <link rel="stylesheet"
@@ -61,7 +59,7 @@
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
-        <p class="fl">Loggerhead <tal:version content="loggerhead_version" /> is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
+        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
       </div>
   </body>
 </html>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2010-01-11 03:26:44 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-06-11 21:16:27 +0000
@@ -18,10 +18,6 @@
             <tal:b content="merged_in"/></a>.
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-	<div tal:attributes="class string:foreign-${change/foreign_vcs}"
-	     tal:condition="change/foreign_vcs" 
-	     tal:repeat="revid_part python:change.foreign_revid.keys()"
-	     tal:content="python:'%s: %s' % (revid_part, change.foreign_revid[revid_part])"/>
         <div class="tags" tal:condition="change/tags" tal:content="string:Tags: ${change/tags}"></div>
         <div class="clear"><!-- --></div>
         <div class="bug" tal:repeat="bug change/bugs">

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-11-26 03:44:40 +0000
+++ loggerhead/util.py	2009-04-02 20:32:12 +0000
@@ -19,6 +19,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+try:
+    from xml.etree import ElementTree as ET
+except ImportError:
+    from elementtree import ElementTree as ET
+
+from simpletal.simpleTALUtils import HTMLStructureCleaner
+
 import base64
 import cgi
 import datetime
@@ -31,13 +38,6 @@
 import os
 import subprocess
 
-try:
-    from xml.etree import ElementTree as ET
-except ImportError:
-    from elementtree import ElementTree as ET
-
-from simpletal.simpleTALUtils import HTMLStructureCleaner
-
 log = logging.getLogger("loggerhead.controllers")
 
 
@@ -129,7 +129,7 @@
     return _wrap_with_date_time_title(date, _displaydate(date))
 
 
-class Container(object):
+class Container (object):
     """
     Convert a dict into an object with attributes.
     """
@@ -217,6 +217,8 @@
 
     return: the same value recieved if not empty, and a '&nbsp;' if it is.
     """
+
+
     if s is None:
         return '&nbsp;'
     elif isinstance(s, int):
@@ -314,7 +316,7 @@
 
     out = str(base)
     if (base < 100) and (dot != 0):
-        out += '.%d' % (dot,)
+        out += '.%d' % (dot)
     if divisor == KILO:
         out += 'K'
     elif divisor == MEG:
@@ -382,6 +384,8 @@
     """
     # Is our root directory itself a branch?
     if is_root:
+        if view == 'directory':
+            directory = 'files'
         breadcrumbs = [{
             'dir_name': path,
             'path': '',
@@ -461,7 +465,7 @@
         now = time.time()
         msec = int(now * 1000) % 1000
         timestr = time.strftime('%Y%m%d%H%M%S',
-                                time.localtime(now)) + ('%03d' % (msec,))
+                                time.localtime(now)) + ('%03d' % msec)
         filename = f.__name__ + '-' + timestr + '.lsprof'
         cPickle.dump(stats, open(filename, 'w'), 2)
         return ret
@@ -533,7 +537,7 @@
     _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
 
     @classmethod
-    def _turn_sigterm_into_systemexit(cls):
+    def _turn_sigterm_into_systemexit(self):
         """
         Attempts to turn a SIGTERM exception into a SystemExit exception.
         """
@@ -547,26 +551,26 @@
         signal.signal(signal.SIGTERM, handle_term)
 
     @classmethod
-    def is_installed(cls):
-        return os.environ.get(cls._reloader_environ_key)
+    def is_installed(self):
+        return os.environ.get(self._reloader_environ_key)
 
     @classmethod
-    def install(cls):
+    def install(self):
         from paste import reloader
         reloader.install(int(1))
 
     @classmethod
-    def restart_with_reloader(cls):
+    def restart_with_reloader(self):
         """Based on restart_with_monitor from paste.script.serve."""
         print 'Starting subprocess with file monitor'
-        while True:
+        while 1:
             args = [sys.executable] + sys.argv
             new_environ = os.environ.copy()
-            new_environ[cls._reloader_environ_key] = 'true'
+            new_environ[self._reloader_environ_key] = 'true'
             proc = None
             try:
                 try:
-                    cls._turn_sigterm_into_systemexit()
+                    self._turn_sigterm_into_systemexit()
                     proc = subprocess.Popen(args, env=new_environ)
                     exit_code = proc.wait()
                     proc = None
@@ -575,7 +579,7 @@
                     return 1
             finally:
                 if (proc is not None
-                    and getattr(os, 'kill', None) is not None):
+                    and hasattr(os, 'kill')):
                     import signal
                     try:
                         os.kill(proc.pid, signal.SIGTERM)
@@ -587,20 +591,3 @@
             if exit_code != 3:
                 return exit_code
             print '-'*20, 'Restarting', '-'*20
-
-
-def convert_file_errors(application):
-    """WSGI wrapper to convert some file errors to Paste exceptions"""
-    def new_application(environ, start_response):
-        try:
-            return application(environ, start_response)
-        except (IOError, OSError), e:
-            import errno
-            from paste import httpexceptions
-            if e.errno == errno.ENOENT:
-                raise httpexceptions.HTTPNotFound()
-            elif e.errno == errno.EACCES:
-                raise httpexceptions.HTTPForbidden()
-            else:
-                raise
-    return new_application

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-10-21 14:40:23 +0000
+++ loggerhead/wholehistory.py	2009-05-29 13:39:28 +0000
@@ -32,7 +32,7 @@
     # Filter ghosts, and null:
     if NULL_REVISION in revision_graph:
         del revision_graph[NULL_REVISION]
-    for key, parents in revision_graph.iteritems():
+    for key, parents in revision_graph.items():
         revision_graph[key] = tuple(parent for parent in parents if parent
             in revision_graph)
     return revision_graph
@@ -48,11 +48,11 @@
     last_revid = branch.last_revision()
 
     log = logging.getLogger('loggerhead.%s' %
-                            (branch.get_config().get_nickname(),))
+                            branch.get_config().get_nickname())
 
     graph = branch.repository.get_graph()
-    parent_map = dict((key, value) for key, value in
-        graph.iter_ancestry([last_revid]) if value is not None)
+    parent_map = dict(((key, value) for key, value in
+         graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
 
@@ -72,7 +72,7 @@
         _rev_indices[revid] = len(_rev_info)
         _rev_info.append([(seq, revid, merge_depth, revno_str, end_of_merge), (), parents])
 
-    for revid in _revision_graph.iterkeys():
+    for revid in _revision_graph.keys():
         if _rev_info[_rev_indices[revid]][0][2] == 0:
             continue
         for parent in _revision_graph[revid]:
@@ -80,6 +80,6 @@
             if revid not in c[1]:
                 c[1] = c[1] + (revid,)
 
-    log.info('built revision graph cache: %r secs' % (time.time() - z,))
+    log.info('built revision graph cache: %r secs' % (time.time() - z))
 
     return (_rev_info, _rev_indices)

=== modified file 'setup.py'
--- setup.py	2009-10-17 06:19:40 +0000
+++ setup.py	2009-06-02 22:10:00 +0000
@@ -18,8 +18,8 @@
 
 """Loggerhead is a web viewer for projects in bazaar"""
 
+
 from distutils.core import setup
-
 import loggerhead
 
 

=== modified file 'start-loggerhead'
--- start-loggerhead	2009-10-17 06:35:33 +0000
+++ start-loggerhead	2009-06-08 23:02:49 +0000
@@ -20,6 +20,7 @@
 
 
 import logging
+import logging.handlers
 from optparse import OptionParser
 import os
 import sys
@@ -34,7 +35,7 @@
 
 from loggerhead import daemon
 from loggerhead.apps.config import Root
-from loggerhead.trace import setup_logging
+from loggerhead.trace import make_handler, setup_logging
 from loggerhead.apps.error import ErrorHandlerApp
 
 
@@ -102,7 +103,7 @@
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
+        sys.stderr.write('PID file: %s\n' % options.pidfile)
         sys.stderr.write('\n')
 
         daemon.daemonize(options.pidfile, home)

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2009-05-13 14:03:48 +0000
+++ stop-loggerhead	2008-10-24 02:26:05 +0000
@@ -32,7 +32,7 @@
 try:
     f = open(options.pidfile, 'r')
 except IOError, e:
-    print 'Pid file %s not found.' % (options.pidfile,)
+    print 'Pid file %s not found.' % options.pidfile
     sys.exit(1)
 
 pid = int(f.readline())
@@ -44,7 +44,7 @@
     sys.exit(1)
 
 print
-print 'Shutting down previous server @ pid %d.' % (pid,)
+print 'Shutting down previous server @ pid %d.' % pid
 print
 
 import signal

